#include "string.h"

#define max(x,y)  (x)>(y)?(x):(y)
#define min(x,y)  (x)<(y)?(x):(y)

bmsearch( text, n, pat, m )   /* Search pat[1..m] in text[1..n] */
char text[], pat[];
int n, m;
{
    int k, j, skip;
    int dd[MAX_PATTERN_SIZE], d[MAX_ALPHABET_SIZE];

    initd( pat, m, d );    /* Preprocess the pattern */
    initdd( pat, m, dd );  
    k = m; skip = dd[1] + 1;
    while( k <= n )        /* Search */
    {
        j = m;
        while( j>0 && text[k] == pat[j] )
        {
            j--; k--;
        }
        if( j == 0 )
        {
            Report_match_at_position( k+1 );
            k += skip;
        }
        else k += max( d[text[k]], dd[j] );
    }
} 

initd( pat, m, d )  /* Preprocess pattern of length m : d table */
char pat[];
int m, d[];
{
    int k;

    for( k=0; k <= MAX_ALPHABET_SIZE; k++ ) d[k] = m;  
    for( k=1; k<=m; k++ ) d[pat[k]] = m-k;
}

initdd( pat, m, dd )  /* Preprocess pattern of length m : dd hat table */
char pat[];
int m, dd[];
{
    int j, k, t, t1, q, q1;
    int f[MAX_PATTERN_SIZE+1];

    for( k=1; k<=m; k++ ) dd[k] = 2*m-k;
    for( j=m, t=m+1; j > 0; j--, t-- )       /* setup the dd hat table */
    {
        f[j] = t;
        while( t <= m && pat[j] != pat[t] )
        {
            dd[t] = min( dd[t], m-j );
            t = f[t];
        }
    }
    q = t; t = m + 1 - q; q1 = 1; /* Rytter's correction */
    for( j=1, t1=0; j <= t; t1++, j++ )
    {
        f[j] = t1;
        while( t1 >= 1 && pat[j] != pat[t1] ) t1 = f[t1];
    }
    while( q < m )
    {
        for( k=q1; k<=q; k++ ) dd[k] = min( dd[k], m+q-k );
        q1 = q + 1; q = q + t - f[t]; t = f[t];
    }
}
