/****************************  const.h  **********************************

   Purpose:	Define globally-useful constant values.

   Provenance:	Written and tested by Q. Chen and E. Fox, March 1991.
   		Edited and tested by S. Wartik, April 1991.
		Revised and tested by S. Wartik, July 1991.

   Notes:	None.
**/

#define NP -1		/* Null pointer for array-based linked lists. */

#define NORM    0	/* Normal return.			*/
#define ABNORM -1	/* Abnormal return.			*/

#define MAPPINGS   4	/* Total number of mapping runs.	*/
#define SEARCHINGS 10	/* Total number of searching runs.	*/

#define MAX_KEY_LENG COLUMNS   /* Maximum length of a key.	*/
#define PRIMES 20              /* Number of primes, used in searching stage. */

#define NOTVISIT  0	/* Indication of an un-visited node.		*/
#define VISIT     1	/* Indication of a visited node.		*/
#define EMPTY    '0'	/* Indication of an empty slot in the disk.	*/
#define FULL     '1'	/* Indication of a filled slot in the disk.	*/

