#include "string.h"

kmpsearch( text, n, pat, m ) /* Search pat[1..m] in text[1..n] */
char text[], pat[];
int n, m;
{
    int j, k, resume;
    int next[MAX_PATTERN_SIZE];

    pat[m+1] = CHARACTER_NOT_IN_THE_TEXT;
    initnext( pat, m+1, next );  /* Preprocess pattern */
    resume = next[m+1];
    j = k = 1;
    do {                         /* Search */
        if( j==0 || text[k]==pat[j] )
        {
            k++; j++;
        }
        else j = next[j];
        if( j > m )
        {
            Report_match_at_position( k-m );
            j = resume;
        }
    } while( k <= n );
	pat[m+1] = END_OF_STRING;
}

initnext( pat, m, next )  /* Preprocess pattern of length m */
char pat[];	
int m, next[];
{
    int i, j;

    i = 1; j = next[1] = 0;
    do
    {
        if( j == 0 || pat[i] == pat[j] )
        {
            i++; j++;
            if( pat[i] != pat[j] ) next[i] = j;
            else                   next[i] = next[j];
        }
        else j = next[j];
    }
    while( i <= m ) ;
}
