#define Q       16647143
#define D       7

rksearch( text, n, pat, m )  /* Search pat[1..m] in text[1..n] */
char text[], pat[];          /* (0 < m <= n)                   */
int n, m;
{
    int h1, h2, dM, i, j;

    dM = 1;
    for( i=1; i<m; i++ ) dM = (dM << D) % Q; /* Compute the signature  */
    h1 = h2 = 0;                             /* of the pattern and of  */
    for( i=1; i<=m; i++ )                    /* the beginning of the   */
    {                                        /* text                   */
         h1 = ((h1 << D) +  pat[i] ) % Q;
         h2 = ((h2 << D) +  text[i] ) % Q;
    }
    for( i = 1; i <= n-m+1; i++ )  /* Search */
    {
        if( h1 == h2 ) /* Potential match */
        {
            for(j=1; j<=m && text[i-1+j] == pat[j]; j++ ); /* check */
            if( j > m )                               /* true match */
                Report_match_at_position( i );
        }
        h2 = (h2 + (Q << D) - text[i]*dM ) % Q;  /* update the signature */
        h2 = ((h2 << D) +  text[i+m] ) % Q;      /* of the text          */
    }
}
