#include <stdio.h>
#include "string.h"

#define B      1
#define WORD  32

sosearch( text, n, pat, m )  /* Search pat[1..m] in text[1..n] */
register char *text;
char pat[];
int n, m;
{
    register char *end;
    register unsigned int state, lim;
    unsigned int T[MAX_ALPHABET_SIZE], i, j;
    char *start;

    if( m > WORD ) 
        Abort( "Use pat size <= word size" );
    for( i=0; i<MAX_ALPHABET_SIZE; i++ ) T[i] = ~0;    /* Preprocessing */
    for( lim=0, j=1, i=1; i<=m; lim |= j, j <<= B, i++ )
        T[pat[i]] &= ~j;
    lim = ~(lim >> B); 
    text++; end = text+n+1;                     /* Search */
    state = ~0;                                 /* Initial state */
    for( start=text; text < end; text++ )
    {
        state = (state << B) | T[*text]; /* Next state */
        if( state < lim ) Report_match_at_position( text-start-m+2 );
    }
}

/* the search loop can be improved as suggested on the book */

Abort( s )
char *s;
{
	fprintf( stderr, "%s\n", s );
	exit(1);
}
